<?php
namespace Avaliacao\Entities;

use Geral\Util\Ambiente;
use Geral\Util\DateUtil;
use Geral\Util\NovoCodigo;
use Setforms2\Shared\Registry;

class Avaliacaogeral extends Base\Avaliacaogeral
{
    public static  function retornaAvaliacaoGeralPk($nrorg, $nravaliacao) {
        $obj = self::getObjectByWhere(
            'NRORG = ? AND NRAVALIACAO = ?',
            array(
                $nrorg,
                $nravaliacao,
            )
        );

        return $obj;
    }

    public function mudaSituacaoAvaliacaoPesquisa($nrorg,
                                                  $nravaliacao,
                                                  $idsituacao
    ){
        $obj = Avaliacaogeral::getObjectsByWhere(
            'NRORG = ? AND NRAVALIACAO = ?',
            array(
                $nrorg,
                $nravaliacao
            )
        );

        /** @var $avaliacao Avaliacaogeral */
        foreach ($obj as $avaliacao) {

            $manager = \Setforms2\Shared\Registry::getEntityManager();

            $avaliacao->setIdsituacaoavaliacao($idsituacao);
            $avaliacao->persist();

            $manager->flush();
        }
    }

//    public static function retornaAvaliacaoGeral($nrorg,
//                                                    $nravaliacao) {
//        $obj = self::getObjectByWhere(
//            'NRORG = ? AND NRAVALIACAO = ?',
//            array(
//                $nrorg,
//                $nravaliacao,
//            )
//        );
//
//        return $obj;
//    }

    public function retornaAvaliacaoGeral
    (
        $nrorg,
        $filial,
        $dt_avaliacao,
        $local_avaliacao,
        $item_avaliacao,
        $cod_questionario,
        $tipo_avaliacao
    ) {
        $consulta = self::consultaAvaliacaoGeral(
            $nrorg,
            $filial,
            $dt_avaliacao,
            $local_avaliacao,
            $item_avaliacao,
            $cod_questionario,
            $tipo_avaliacao);
        return $consulta;
    }

    public static function consultaAvaliacaoGeral($nrorg,
                                                  $filial,
                                                  $dt_avaliacao,
                                                  $local_avaliacao,
                                                  $item_avaliacao,
                                                  $cod_questionario,
                                                  $tipo_avaliacao) {
        $obj = self::getObjectByWhere(
            'NRORG = ? AND
             CDFILIAL = ? AND
             DTREFEAVALIACAO = ? AND
             NRLOCALAVALIACAO = ? AND
             NRITEMAVALIACAO = ? AND
             NRPADRAVALIACAO = ? AND
             NRTIPOAVALIACAO = ?',
            array(
                $nrorg,
                $filial,
                $dt_avaliacao,
                $local_avaliacao,
                $item_avaliacao,
                $cod_questionario,
                $tipo_avaliacao
            )
        );

        return $obj;
    }

    public function incluiAvaliacaoGeral(
                                        $nome_avaliacao,
                                        $nrorg,
                                        $filial,
                                        $local_avaliacao,
                                        $data_voto,
                                        $item_avaliacao,
                                        $cod_questionario,
                                        $tipo_avaliacao,
                                        $origem)
        {
        try {

//            $manager = \Setforms2\Shared\Registry::getEntityManager();

            $obj = new self();
            $obj->setCdfilial($filial);
            $obj->setNmavaliacao($nome_avaliacao);
            $obj->setNravaliacao(NovoCodigo::geraCodigo($nrorg, 'AVALIACAOGERAL',1,10,true));
            $obj->setNrlocalavaliacao($local_avaliacao);
            $obj->setDtrefeavaliacao(DateUtil::getDataDeString($data_voto, DateUtil::FORMATO_BRASILEIRO, true));
            $obj->setDtinirealizaval(DateUtil::getDataDeString($data_voto, DateUtil::FORMATO_BRASILEIRO, true));
            $obj->setDtfimrealizaval(DateUtil::getDataDeString($data_voto, DateUtil::FORMATO_BRASILEIRO, true));
            $obj->setNritemavaliacao($item_avaliacao);
            $obj->setCdoperinclusao(Ambiente::getCdOperador());
            $obj->setCdoperultatu(Ambiente::getCdOperador());
            $obj->setNrpadravaliacao($cod_questionario);
            $obj->setNrtipoavaliacao($tipo_avaliacao);
            $obj->setIdsituacaoavaliacao('PENDENTE');
            $obj->setDtinclusao(DateUtil::getDataAtual());
            $obj->setDtultatu(DateUtil::getDataAtual());
            $obj->setQtprevparticaval(0);
            $obj->setIdorigemavaliacao($origem);
            $obj->setVraprovacaoaval(0);
            $obj->setIdativo('S');
            $obj->setIdregisexecaval('S');
            $obj->setIdparticipaaval('INSCRICAO');
            $obj->setNrorg($nrorg);
            $obj->setNrorginclusao($nrorg);

            $obj->persist();

            Registry::getEntityManager()->flush();

            return $obj;

        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }

    }

    public static function retornaAvaliacoesPorData($nrorg, $filial, $dt_avaliacao) {
        $objs = self::getObjectsByWhere(
            'NRORG = ? AND CDFILIAL = ? AND DTREFEAVALIACAO = ?',
            array(
                $nrorg,
                $filial,
                $dt_avaliacao,
            )
        );
        return $objs;
    }

    public static function excluiAvaliacaoGeral($nrorg, $nravaliacao) {
        try {
            $sql = "DELETE FROM AVALIACAOGERAL
                     WHERE NRORG = {$nrorg}
                       AND NRAVALIACAO = {$nravaliacao}";
            \Setforms2\Shared\Connection::getInstance()->execute($sql);
            return true;
        } catch(\Exception $e) {
            return false;
        }
    }

    public function atualizaAvaliacaoParticipantesPrevistos($nrorg,
                                                            $nravaliacao,
                                                            $qt_total_previsto
    ){
        $obj = Avaliacaogeral::getObjectsByWhere(
            'NRORG = ? AND NRAVALIACAO = ?',
            array(
                $nrorg,
                $nravaliacao
            )
        );

        /** @var $avaliacao Avaliacaogeral */
        foreach ($obj as $avaliacao) {
            $avaliacao->setQtprevparticaval($qt_total_previsto);
            $avaliacao->persist();
        }
        return true;
    }

    public static function retornaSomaComensaisEfetivos($nrorg, $filial, $dt_avaliacao, $questionario){

        $query = "SELECT AV.QTPREVPARTICAVAL, CA.QTCOMEFETCAR
                    FROM (SELECT SUM(NVL(AV.QTPREVPARTICAVAL,0)) QTPREVPARTICAVAL
                            FROM AVALIACAOGERAL AV
                           WHERE AV.NRORG = {$nrorg}
                             AND AV.CDFILIAL = {$filial}
                             AND AV.DTREFEAVALIACAO = '{$dt_avaliacao}'
                             AND AV.NRPADRAVALIACAO = {$questionario}
                             AND AV.IDSITUACAOAVALIACAO IN ('PENDENTE','CONCLUIDA')) AV,
                         (SELECT SUM(NVL(CA.QTCOMEFETCAR, 0)) QTCOMEFETCAR
                            FROM (SELECT DISTINCT SE.CDFILIAL, SE.CDSERVFILI, SE.NRORG
                                    FROM AVL_SERVICOAVAL SE, AVALIACAOGERAL AV
                                   WHERE AV.NRORG = {$nrorg}
                                     AND AV.CDFILIAL = {$filial}
                                     AND AV.DTREFEAVALIACAO = '{$dt_avaliacao}'
                                     AND AV.NRPADRAVALIACAO = {$questionario}
                                     AND AV.IDSITUACAOAVALIACAO IN ('PENDENTE','CONCLUIDA')
                                     AND SE.NRAVALIACAO = AV.NRAVALIACAO
                                     AND SE.NRORG = AV.NRORG) SE, CARDADIA CA
                   WHERE CA.NRORG = {$nrorg}
                     AND CA.CDFILIAL = {$filial}
                     AND CA.DTCARDAPIO = '{$dt_avaliacao}'
                     AND SE.CDFILIAL = CA.CDFILIAL
                     AND SE.CDSERVFILI = CA.CDSERVFILI
                     AND SE.NRORG = CA.NRORG) CA";

        $result = \Setforms2\Runtime\Framework::getInstance()->fetchAll($query);
        return $result;
    }
}