<?php
namespace Geral\Util;
/**
 * Created by JetBrains PhpStorm.
 * User: gustavoavila
 * Date: 17/12/12
 * Time: 15:07
 * To change this template use File | Settings | File Templates.
 */
class DatasetRepository
{

    private static $instance;
    private $datasets = array();

    public static function getInstance()
    {
        if (!isset(self::$instance)){
            self::$instance = new self();
        }

        return self::$instance;
    }

    /**
     * @param $datasetId
     * @return bool(false)|\Geral\Util\Dataset
     */
    public function get($datasetId)
    {
        return isset($this->datasets[$datasetId]) ? $this->datasets[$datasetId] : false;
    }

    public function exists($datasetId){
        return isset($this->datasets[$datasetId]);
    }

    public function add($datasetId, \Geral\Util\Dataset $dataset){
        $this->datasets[$datasetId] = $dataset;
    }

    public function set($datasetId, \Geral\Util\Dataset $dataset){
        if(isset($this->datasets[$datasetId])){
            $this->datasets[$datasetId] = $dataset;
        }
    }

    public function remove($datasetId){
        if(isset($this->datasets[$datasetId])){
            unset($this->datasets[$datasetId]);
        }
    }
}
